using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SyncFusionParReproduce
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private MyOwnDisplayForm frm = new MyOwnDisplayForm();
		private Control[]  ControlsTop = new Control[2];
		private Control[]  ControlsBottom = new Control[2];
		private Control[]  ControlsLeft = new Control[2];
		private Control[]  ControlsRight = new Control[2];
		private Control[]  ControlsCenter = new Control[2];
		int topHeight;
		int bottomHeight;

		private Syncfusion.Windows.Forms.Tools.TabbedGroupedMDIManager tabbedMDIManager = new Syncfusion.Windows.Forms.Tools.TabbedGroupedMDIManager();
		Syncfusion.Windows.Forms.Tools.DockingManager dockingManager;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		
		private void InitializeDockObjects()
		{
			
			this.dockingManager = new Syncfusion.Windows.Forms.Tools.DockingManager();
			//The drag allow event to abort the Drag operation - code added by - Kanthi
//			this.dockingManager.DragAllow += new Syncfusion.Windows.Forms.Tools.DragAllowEventHandler(dockingManager_DragAllow);
			//The drag allow event to abort the Drag operation - code added by - Kanthi
			this.dockingManager.BeginInit();
			this.dockingManager.HostForm = (System.Windows.Forms.Form)this.frm;

			this.dockingManager.PersistState = false;
			this.dockingManager.DisallowFloating = true;
		
			this.dockingManager.EndInit();
//
//			frm.Resize +=new EventHandler(taskContainer_Resize);
//			frm.Activated +=new EventHandler(taskContainer_Activated);
//			frm.Deactivate+=new EventHandler(taskContainer_Deactivate);
//			frm.Closing +=new System.ComponentModel.CancelEventHandler(taskContainer_Closing);
		}

		public Form1()
		{
		 	//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.tabbedMDIManager.AttachToMdiContainer(this);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.IsMdiContainer = true;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "New Form";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Create SyncFusionForm";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 333);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if(!frm.IsDisposed)
			{
				frm.Close();
				frm.Dispose();
			}
			frm = new MyOwnDisplayForm();
			frm.MdiParent = this;
			frm.Hide();
			frm.Show();
			

			bool topCollapse = true;
			bool bottomCollapse = true;
			ControlsTop[0] = new Control1();
			ControlsTop[0].Text = "Cpntrol1";

			ControlsTop[1] = new Control5();
			ControlsTop[0].Text = "Cpntrol5";
			ControlsBottom[0] = new Control2();
			ControlsTop[0].Text = "Cpntrol2";
			ControlsBottom[1] = new Control1();
			ControlsTop[1].Text = "Cpntrol1";
			bool leftCollapse = true;
			int leftWidth = 80;
			ControlsLeft[0] = new Control1();
			ControlsTop[0].Text = "Cpntrol1";
			ControlsLeft[1] = new Control2();
			ControlsTop[0].Text = "Cpntrol2";
			bool rightCollapse = true;
			int rightWidth = 80;
			ControlsRight[0] = new Control3();
			ControlsTop[0].Text = "Cpntrol3";
			ControlsRight[1] = new Control4();
			ControlsTop[1].Text = "Cpntrol4";

			InitializeDockObjects();
			topHeight = 130;
			bottomHeight = 130;
			DockControlsTop(ControlsTop,topCollapse,topHeight);
			DockControlsBottom(ControlsBottom,bottomCollapse,bottomHeight);
			DockControlsLeft(ControlsLeft,leftCollapse,leftWidth);
			DockControlsRight(ControlsRight,rightCollapse,rightWidth);
			DockControlsRight(ControlsRight,rightCollapse,rightWidth);
			ArrayList listCentreRegion = new ArrayList();

			listCentreRegion.Add(ControlsRight[0]);
			listCentreRegion.Add(ControlsRight[1] );
			listCentreRegion.Add(ControlsBottom[1]);
			listCentreRegion.Add(ControlsTop[1]);
			
			DockControlsCentre(listCentreRegion,true,frm.ClientSize.Height);

			frm.WindowState = FormWindowState.Maximized;
			
			
		}

		/// <summary>
		/// Dock controls to the specified region.Hook to selected index changed event.
		/// Set IsVisible true to the selected tab.
		/// </summary>
		/// <param name="controlCollection"></param>
		/// <param name="collapse"></param>
		/// <param name="width"></param>
		private void DockControlsLeft(Control[] controlCollection,bool collapse,int width)
		{
			if(controlCollection==null || controlCollection.Length <= 0)
			{
				return;
			}

			Control  firstControl = controlCollection[controlCollection.Length-1];
			this.dockingManager.DockControl(firstControl,frm,Syncfusion.Windows.Forms.Tools.DockingStyle.Left,width);
			this.dockingManager.SetDockLabel(firstControl, firstControl.Text);
			this.dockingManager.SetCloseButtonVisibility(firstControl,false);
			this.dockingManager.SetAutoHideButtonVisibility(firstControl,collapse);

			if(controlCollection.Length >1)
				for(int i = controlCollection.Length-2;i>=0;i--)
				{
					this.dockingManager.DockControl(controlCollection[i],firstControl,Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed,width);
					this.dockingManager.SetDockLabel(controlCollection[i],controlCollection[i].Text);
					this.dockingManager.SetCloseButtonVisibility(controlCollection[i],false);
					this.dockingManager.SetAutoHideButtonVisibility(controlCollection[i],collapse);
				}	
		
			this.SetIsVisible(firstControl,controlCollection);
		}


		private void DockControlsRight(Control[] controlCollection,bool collapse,int width)
		{
			if(controlCollection==null || controlCollection.Length <= 0)
			{
				return;
			}
			Control  firstControl = controlCollection[controlCollection.Length-1];
			this.dockingManager.DockControl(firstControl,frm,Syncfusion.Windows.Forms.Tools.DockingStyle.Right,width);
			this.dockingManager.SetDockLabel(firstControl, firstControl.Text);
			this.dockingManager.SetCloseButtonVisibility(firstControl,false);
			this.dockingManager.SetAutoHideButtonVisibility(firstControl,collapse);

			if(controlCollection.Length >1)
				for(int i = controlCollection.Length-2;i>=0;i--)
				{
					this.dockingManager.DockControl(controlCollection[i],firstControl,Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed,width);
					this.dockingManager.SetDockLabel(controlCollection[i],controlCollection[i].Text);
					this.dockingManager.SetCloseButtonVisibility(controlCollection[i],false);
					this.dockingManager.SetAutoHideButtonVisibility(controlCollection[i],collapse);
				}	

			this.SetIsVisible(firstControl,controlCollection);
		}


		private void DockControlsTop(Control[] controlCollection,bool collapse,int height)
		{
			if(controlCollection==null || controlCollection.Length <= 0)
			{
				return;
			}
			Control  firstControl = controlCollection[controlCollection.Length-1];
			this.dockingManager.DockControl(firstControl,frm,Syncfusion.Windows.Forms.Tools.DockingStyle.Top,height);
			this.dockingManager.SetDockLabel(firstControl, firstControl.Text);
			this.dockingManager.SetCloseButtonVisibility(firstControl,false);
			this.dockingManager.SetAutoHideButtonVisibility(firstControl,collapse);

			if(controlCollection.Length >1)
				for(int i = controlCollection.Length-2;i>=0;i--)
				{
					this.dockingManager.DockControl(controlCollection[i],firstControl,Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed,height);
					this.dockingManager.SetDockLabel(controlCollection[i],controlCollection[i].Text);
					this.dockingManager.SetCloseButtonVisibility(controlCollection[i],false);
					this.dockingManager.SetAutoHideButtonVisibility(controlCollection[i],collapse);
				}	
			this.SetIsVisible(firstControl,controlCollection);
		}


		private void DockControlsBottom(Control[] controlCollection,bool collapse,int height)
		{
			if(controlCollection==null || controlCollection.Length <= 0)
			{
				return;
			}
			Control firstControl = controlCollection[controlCollection.Length-1];
			this.dockingManager.DockControl(firstControl,frm,Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom,height);
			this.dockingManager.SetDockLabel(firstControl, firstControl.Text);
			this.dockingManager.SetCloseButtonVisibility(firstControl,false);
			this.dockingManager.SetAutoHideButtonVisibility(firstControl,collapse);

			if(controlCollection.Length >1)
				for(int i = controlCollection.Length-2;i>=0;i--)
				{
					this.dockingManager.DockControl(controlCollection[i],firstControl,Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed,height);
					this.dockingManager.SetDockLabel(controlCollection[i],controlCollection[i].Text);
					this.dockingManager.SetCloseButtonVisibility(controlCollection[i],false);
					this.dockingManager.SetAutoHideButtonVisibility(controlCollection[i],collapse);
				}	

			this.SetIsVisible(firstControl,controlCollection);

		}


		private void DockControlsCentre(ArrayList listCenterRegion ,bool collapse,int height)
		{
			Control firstControl = new Control2();
			this.dockingManager.DockControl(firstControl,frm,Syncfusion.Windows.Forms.Tools.DockingStyle.Fill, 280);
			foreach(object obj in listCenterRegion)
			{
				Control detailControl = (Control)obj;
				this.dockingManager.DockControl(detailControl ,firstControl,Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed,this.Height - 340);
				this.dockingManager.SetCloseButtonVisibility(detailControl,false);
				this.dockingManager.SetAutoHideButtonVisibility(detailControl,collapse);
			}
		}
		/// Generic method to Set IsVisible true for default control in a region/section if its present or the first control with index 0,after tabbed docking.
		/// And Hook for DockingManager tab_SelectedIndexChanged.
		/// </summary>
		/// <param name="firstControl">Control Host</param>
		/// <param name="controls">Array of Control in a region/section.</param>
		private void SetIsVisible(Control firstControl,Control[] controls)
		{
			Control defaultControl  = null;
			if(defaultControl!=null)
				this.dockingManager.ActivateControl(defaultControl);
			
			
			Syncfusion.Windows.Forms.Tools.DockHost dhost = firstControl.Parent as Syncfusion.Windows.Forms.Tools.DockHost;
			Syncfusion.Windows.Forms.Tools.DockHostController dhc = dhost.InternalController as Syncfusion.Windows.Forms.Tools.DockHostController;
			if(dhc.ParentController is Syncfusion.Windows.Forms.Tools.DockTabController)
			{
				Syncfusion.Windows.Forms.Tools.DockTabControl dockTab = (dhc.ParentController as Syncfusion.Windows.Forms.Tools.DockTabController).TabControl;
//				dockTab.SelectedIndexChanged+=new EventHandler(docktab_SelectedIndexChanged);
				Syncfusion.Windows.Forms.Tools.DockTabPage	pageAdv = (Syncfusion.Windows.Forms.Tools.DockTabPage)dockTab.SelectedTab;
				Control selectedControl = (Control)pageAdv.dhcClient.HostControl.Controls[0];

			}
		}

	}
}
